---
name: Bug report
about: Create a report to help us improve

---

**Describe the bug**
A clear and concise description of what the bug is.
Is this a build problem, or a problem while running the `curv` command?

**Build Log**
If this is a build problem, then paste the complete build log here.
For example, type the following command in the terminal:
```
$ make >& buildlog
```
then paste the contents of the `buildlog` file here.

**Curv Program**
If this is a problem while running a Curv program,
then paste the entire Curv program here.

**To Reproduce**
Steps to reproduce the behavior:
1. Go to '...'
2. Click on '....'
3. Scroll down to '....'
4. See error

**Expected behavior**
A clear and concise description of what you expected to happen.

**Screenshots**
If applicable, add screenshots to help explain your problem.

**System Information (please complete the following information):**
 - Operating System: [e.g. "Ubuntu 16.04.4" or "macOS 10.10"]
 - CPU manufacturer, model, version, and # of cores:
 - Amount of system memory:
 - GPU manufacturer, model and version:
 - GPU driver, if on Linux:
 - Are you running the `curv` command using a remote viewing protocol like VNC or NX?
 - Are you running the `curv` command inside a VM?
 - Curv Version: run the command `curv --version` and paste the output here.

**Additional context**
Add any other context about the problem here.
